Merge branch 'jk/maint-http-half-auth-push' into maint
[git.git] / git-filter-branch.sh
blob178e45305d2b66bbe5a0c0902d989ea66888869b
1 #!/bin/sh
3 # Rewrite revision history
4 # Copyright (c) Petr Baudis, 2006
5 # Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
7 # Lets you rewrite the revision history of the current branch, creating
8 # a new branch. You can specify a number of filters to modify the commits,
9 # files and trees.
11 # The following functions will also be available in the commit filter:
13 functions=$(cat << \EOF
14 warn () {
15 echo "$*" >&2
18 map()
20 # if it was not rewritten, take the original
21 if test -r "$workdir/../map/$1"
22 then
23 cat "$workdir/../map/$1"
24 else
25 echo "$1"
29 # if you run 'skip_commit "$@"' in a commit filter, it will print
30 # the (mapped) parents, effectively skipping the commit.
32 skip_commit()
34 shift;
35 while [ -n "$1" ];
37 shift;
38 map "$1";
39 shift;
40 done;
43 # if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
44 # it will skip commits that leave the tree untouched, commit the other.
45 git_commit_non_empty_tree()
47 if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
48 map "$3"
49 else
50 git commit-tree "$@"
53 # override die(): this version puts in an extra line break, so that
54 # the progress is still visible
56 die()
58 echo >&2
59 echo "$*" >&2
60 exit 1
62 EOF
65 eval "$functions"
67 # When piped a commit, output a script to set the ident of either
68 # "author" or "committer
70 set_ident () {
71 lid="$(echo "$1" | tr "[A-Z]" "[a-z]")"
72 uid="$(echo "$1" | tr "[a-z]" "[A-Z]")"
73 pick_id_script='
74 /^'$lid' /{
75 s/'\''/'\''\\'\'\''/g
77 s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
78 s/'\''/'\''\'\'\''/g
79 s/.*/GIT_'$uid'_NAME='\''&'\''; export GIT_'$uid'_NAME/p
82 s/^'$lid' [^<]* <\([^>]*\)> .*$/\1/
83 s/'\''/'\''\'\'\''/g
84 s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
87 s/^'$lid' [^<]* <[^>]*> \(.*\)$/@\1/
88 s/'\''/'\''\'\'\''/g
89 s/.*/GIT_'$uid'_DATE='\''&'\''; export GIT_'$uid'_DATE/p
95 LANG=C LC_ALL=C sed -ne "$pick_id_script"
96 # Ensure non-empty id name.
97 echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
100 USAGE="[--env-filter <command>] [--tree-filter <command>]
101 [--index-filter <command>] [--parent-filter <command>]
102 [--msg-filter <command>] [--commit-filter <command>]
103 [--tag-name-filter <command>] [--subdirectory-filter <directory>]
104 [--original <namespace>] [-d <directory>] [-f | --force]
105 [<rev-list options>...]"
107 OPTIONS_SPEC=
108 . git-sh-setup
110 if [ "$(is_bare_repository)" = false ]; then
111 require_clean_work_tree 'rewrite branches'
114 tempdir=.git-rewrite
115 filter_env=
116 filter_tree=
117 filter_index=
118 filter_parent=
119 filter_msg=cat
120 filter_commit=
121 filter_tag_name=
122 filter_subdir=
123 orig_namespace=refs/original/
124 force=
125 prune_empty=
126 remap_to_ancestor=
127 while :
129 case "$1" in
131 shift
132 break
134 --force|-f)
135 shift
136 force=t
137 continue
139 --remap-to-ancestor)
140 # deprecated ($remap_to_ancestor is set now automatically)
141 shift
142 remap_to_ancestor=t
143 continue
145 --prune-empty)
146 shift
147 prune_empty=t
148 continue
153 break;
154 esac
156 # all switches take one argument
157 ARG="$1"
158 case "$#" in 1) usage ;; esac
159 shift
160 OPTARG="$1"
161 shift
163 case "$ARG" in
165 tempdir="$OPTARG"
167 --env-filter)
168 filter_env="$OPTARG"
170 --tree-filter)
171 filter_tree="$OPTARG"
173 --index-filter)
174 filter_index="$OPTARG"
176 --parent-filter)
177 filter_parent="$OPTARG"
179 --msg-filter)
180 filter_msg="$OPTARG"
182 --commit-filter)
183 filter_commit="$functions; $OPTARG"
185 --tag-name-filter)
186 filter_tag_name="$OPTARG"
188 --subdirectory-filter)
189 filter_subdir="$OPTARG"
190 remap_to_ancestor=t
192 --original)
193 orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
196 usage
198 esac
199 done
201 case "$prune_empty,$filter_commit" in
203 filter_commit='git commit-tree "$@"';;
205 filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
209 die "Cannot set --prune-empty and --commit-filter at the same time"
210 esac
212 case "$force" in
214 rm -rf "$tempdir"
217 test -d "$tempdir" &&
218 die "$tempdir already exists, please remove it"
219 esac
220 mkdir -p "$tempdir/t" &&
221 tempdir="$(cd "$tempdir"; pwd)" &&
222 cd "$tempdir/t" &&
223 workdir="$(pwd)" ||
224 die ""
226 # Remove tempdir on exit
227 trap 'cd ../..; rm -rf "$tempdir"' 0
229 ORIG_GIT_DIR="$GIT_DIR"
230 ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
231 ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
232 GIT_WORK_TREE=.
233 export GIT_DIR GIT_WORK_TREE
235 # Make sure refs/original is empty
236 git for-each-ref > "$tempdir"/backup-refs || exit
237 while read sha1 type name
239 case "$force,$name" in
240 ,$orig_namespace*)
241 die "Cannot create a new backup.
242 A previous backup already exists in $orig_namespace
243 Force overwriting the backup with -f"
245 t,$orig_namespace*)
246 git update-ref -d "$name" $sha1
248 esac
249 done < "$tempdir"/backup-refs
251 # The refs should be updated if their heads were rewritten
252 git rev-parse --no-flags --revs-only --symbolic-full-name \
253 --default HEAD "$@" > "$tempdir"/raw-heads || exit
254 sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
256 test -s "$tempdir"/heads ||
257 die "Which ref do you want to rewrite?"
259 GIT_INDEX_FILE="$(pwd)/../index"
260 export GIT_INDEX_FILE
262 # map old->new commit ids for rewriting parents
263 mkdir ../map || die "Could not create map/ directory"
265 # we need "--" only if there are no path arguments in $@
266 nonrevs=$(git rev-parse --no-revs "$@") || exit
267 if test -z "$nonrevs"
268 then
269 dashdash=--
270 else
271 dashdash=
272 remap_to_ancestor=t
275 rev_args=$(git rev-parse --revs-only "$@")
277 case "$filter_subdir" in
279 eval set -- "$(git rev-parse --sq --no-revs "$@")"
282 eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
283 "$filter_subdir")"
285 esac
287 git rev-list --reverse --topo-order --default HEAD \
288 --parents --simplify-merges $rev_args "$@" > ../revs ||
289 die "Could not get the commits"
290 commits=$(wc -l <../revs | tr -d " ")
292 test $commits -eq 0 && die "Found nothing to rewrite"
294 # Rewrite the commits
296 git_filter_branch__commit_count=0
297 while read commit parents; do
298 git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
299 printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
301 case "$filter_subdir" in
303 git read-tree -i -m $commit
306 # The commit may not have the subdirectory at all
307 err=$(git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
308 if ! git rev-parse -q --verify $commit:"$filter_subdir"
309 then
310 rm -f "$GIT_INDEX_FILE"
311 else
312 echo >&2 "$err"
313 false
316 esac || die "Could not initialize the index"
318 GIT_COMMIT=$commit
319 export GIT_COMMIT
320 git cat-file commit "$commit" >../commit ||
321 die "Cannot read commit $commit"
323 eval "$(set_ident AUTHOR <../commit)" ||
324 die "setting author failed for commit $commit"
325 eval "$(set_ident COMMITTER <../commit)" ||
326 die "setting committer failed for commit $commit"
327 eval "$filter_env" < /dev/null ||
328 die "env filter failed: $filter_env"
330 if [ "$filter_tree" ]; then
331 git checkout-index -f -u -a ||
332 die "Could not checkout the index"
333 # files that $commit removed are now still in the working tree;
334 # remove them, else they would be added again
335 git clean -d -q -f -x
336 eval "$filter_tree" < /dev/null ||
337 die "tree filter failed: $filter_tree"
340 git diff-index -r --name-only --ignore-submodules $commit &&
341 git ls-files --others
342 ) > "$tempdir"/tree-state || exit
343 git update-index --add --replace --remove --stdin \
344 < "$tempdir"/tree-state || exit
347 eval "$filter_index" < /dev/null ||
348 die "index filter failed: $filter_index"
350 parentstr=
351 for parent in $parents; do
352 for reparent in $(map "$parent"); do
353 parentstr="$parentstr -p $reparent"
354 done
355 done
356 if [ "$filter_parent" ]; then
357 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
358 die "parent filter failed: $filter_parent"
361 sed -e '1,/^$/d' <../commit | \
362 eval "$filter_msg" > ../message ||
363 die "msg filter failed: $filter_msg"
364 workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
365 $(git write-tree) $parentstr < ../message > ../map/$commit ||
366 die "could not write rewritten commit"
367 done <../revs
369 # If we are filtering for paths, as in the case of a subdirectory
370 # filter, it is possible that a specified head is not in the set of
371 # rewritten commits, because it was pruned by the revision walker.
372 # Ancestor remapping fixes this by mapping these heads to the unique
373 # nearest ancestor that survived the pruning.
375 if test "$remap_to_ancestor" = t
376 then
377 while read ref
379 sha1=$(git rev-parse "$ref"^0)
380 test -f "$workdir"/../map/$sha1 && continue
381 ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
382 test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
383 done < "$tempdir"/heads
386 # Finally update the refs
388 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
389 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
390 echo
391 while read ref
393 # avoid rewriting a ref twice
394 test -f "$orig_namespace$ref" && continue
396 sha1=$(git rev-parse "$ref"^0)
397 rewritten=$(map $sha1)
399 test $sha1 = "$rewritten" &&
400 warn "WARNING: Ref '$ref' is unchanged" &&
401 continue
403 case "$rewritten" in
405 echo "Ref '$ref' was deleted"
406 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
407 die "Could not delete $ref"
409 $_x40)
410 echo "Ref '$ref' was rewritten"
411 if ! git update-ref -m "filter-branch: rewrite" \
412 "$ref" $rewritten $sha1 2>/dev/null; then
413 if test $(git cat-file -t "$ref") = tag; then
414 if test -z "$filter_tag_name"; then
415 warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
416 warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
418 else
419 die "Could not rewrite $ref"
424 # NEEDSWORK: possibly add -Werror, making this an error
425 warn "WARNING: '$ref' was rewritten into multiple commits:"
426 warn "$rewritten"
427 warn "WARNING: Ref '$ref' points to the first one now."
428 rewritten=$(echo "$rewritten" | head -n 1)
429 git update-ref -m "filter-branch: rewrite to first" \
430 "$ref" $rewritten $sha1 ||
431 die "Could not rewrite $ref"
433 esac
434 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
435 exit
436 done < "$tempdir"/heads
438 # TODO: This should possibly go, with the semantics that all positive given
439 # refs are updated, and their original heads stored in refs/original/
440 # Filter tags
442 if [ "$filter_tag_name" ]; then
443 git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
444 while read sha1 type ref; do
445 ref="${ref#refs/tags/}"
446 # XXX: Rewrite tagged trees as well?
447 if [ "$type" != "commit" -a "$type" != "tag" ]; then
448 continue;
451 if [ "$type" = "tag" ]; then
452 # Dereference to a commit
453 sha1t="$sha1"
454 sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
457 [ -f "../map/$sha1" ] || continue
458 new_sha1="$(cat "../map/$sha1")"
459 GIT_COMMIT="$sha1"
460 export GIT_COMMIT
461 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
462 die "tag name filter failed: $filter_tag_name"
464 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
466 if [ "$type" = "tag" ]; then
467 new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
468 "$new_sha1" "$new_ref"
469 git cat-file tag "$ref" |
470 sed -n \
471 -e '1,/^$/{
472 /^object /d
473 /^type /d
474 /^tag /d
475 }' \
476 -e '/^-----BEGIN PGP SIGNATURE-----/q' \
477 -e 'p' ) |
478 git mktag) ||
479 die "Could not create new tag object for $ref"
480 if git cat-file tag "$ref" | \
481 sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
482 then
483 warn "gpg signature stripped from tag object $sha1t"
487 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
488 die "Could not write tag $new_ref"
489 done
492 cd ../..
493 rm -rf "$tempdir"
495 trap - 0
497 unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
498 test -z "$ORIG_GIT_DIR" || {
499 GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
501 test -z "$ORIG_GIT_WORK_TREE" || {
502 GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
503 export GIT_WORK_TREE
505 test -z "$ORIG_GIT_INDEX_FILE" || {
506 GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
507 export GIT_INDEX_FILE
510 if [ "$(is_bare_repository)" = false ]; then
511 git read-tree -u -m HEAD || exit
514 exit 0